import 'package:aplus_chat/global.dart';
import 'package:aplus_chat/model/set_user_role_model.dart';
import 'package:get/get.dart';
import 'package:get_storage/get_storage.dart';

class AppStorages {
  static late GetStorage box;
  static var myUserId = "";
  static var secKey = "";
  static var myEmail = "".obs;
  static SetUserRole myRoles = SetUserRole();
  static var chatFCMToken = "".obs;
  static var myMobile = "".obs;
  static var myUserName = "".obs;
  static var myFirstName = "".obs;
  static var myLastName = "".obs;
  static var myProfilePicture = "".obs;

  static initializeApp() async {
    await GetStorage.init('APlus_chat');
    box = GetStorage('APlus_chat');
  }

  /* to set secretkey */
  static setSecKey(String secKey) {
    box.write(SessionKeys.secKey, secKey);
  }

  /* get secretkey */
  static getSecKey() {
    if (box.hasData(SessionKeys.secKey)) {
      return box.read(SessionKeys.secKey);
    }
    return "";
  }

  /* to set chat user id */
  static setChatUserId(String userId) {
    box.write(SessionKeys.chatUserId, userId);
  }

  /* to get chat user id */
  static getChatUserId() {
    if (box.hasData(SessionKeys.chatUserId)) {
      return box.read(SessionKeys.chatUserId);
    }
    return "";
  }

  /* to set chat user data */
  static setChatUserData(String userData, {setKey}) {
    box.write(setKey, userData);
  }

  /* to get chat user data */
  static getChatUserData({getKey}) {
    if (box.hasData(getKey)) {
      return box.read(getKey);
    }
    return "";
  }

  /* to set chat user data */
  static setChatUserRoles(SetUserRole roles) {
    box.write(SessionKeys.chatUserRole, setRoleModelToJson(roles));
  }

  /* to get chat user data */
  static getChatUserRoles() {
    if (box.hasData(SessionKeys.chatUserRole)) {
      var json = box.read(SessionKeys.chatUserRole);
      SetUserRole userRole = setRoleFromJson(json);
      return userRole;
    }
    return null;
  }
}
