// To parse this JSON data, do
//
//     final contactsListModel = contactsListModelFromJson(jsonString);

import 'dart:convert';

import 'package:get/get.dart';

ContactsListModel contactsListModelFromJson(str) =>
    ContactsListModel.fromJson(json.decode(str));

String contactsListModelToJson(ContactsListModel data) =>
    json.encode(data.toJson());

class ContactsListModel {
  ContactsListModel({
    this.success,
    this.count,
    this.list,
  });

  bool? success;
  int? count;
  List<ChatUserList>? list;

  factory ContactsListModel.fromJson(Map<String, dynamic> json) =>
      ContactsListModel(
        success: json["success"],
        count: json["count"],
        list: List<ChatUserList>.from(
            json["list"].map((x) => ChatUserList.fromJson(x))),
      );

  Map<String, dynamic> toJson() => {
        "success": success,
        "count": count,
        "list": List<dynamic>.from(list!.map((x) => x.toJson())),
      };
}

class ChatUserList {
  ChatUserList({
    this.id,
    this.username,
    this.firstName,
    this.lastName,
    this.email,
    this.phone,
    this.profilePicture,
    this.userId,
    this.isActive,
    this.createdAt,
  });

  String? id;
  String? username;
  String? firstName;
  String? lastName;
  String? email;
  String? phone;
  String? profilePicture;
  String? userId;
  bool? isActive;
  String? createdAt;
  var isSelected = false.obs;

  factory ChatUserList.fromJson(Map<String, dynamic> json) => ChatUserList(
        id: json["_id"].toString(),
        username: json["username"],
        firstName: json["firstName"],
        lastName: json["lastName"],
        email: json["email"],
        phone: json["phone"].toString(),
        profilePicture: json["profilePicture"],
        userId: json["userId"].toString(),
        isActive: json["isActive"],
        createdAt: json["createdAt"],
      );

  Map<String, dynamic> toJson() => {
        "_id": id,
        "username": username,
        "firstName": firstName,
        "lastName": lastName,
        "email": email,
        "phone": phone,
        "profilePicture": profilePicture,
        "userId": userId,
        "isActive": isActive,
        "createdAt": createdAt,
      };
}
