// To parse this JSON data, do
//
//     final messagesModel = messagesModelFromJson(jsonString);

import 'dart:convert';

List<MessagesModel> messagesModelFromJson(String str) =>
    List<MessagesModel>.from(
        json.decode(str).map((x) => MessagesModel.fromJson(x)));

String messagesModelToJson(List<MessagesModel> data) =>
    json.encode(List<dynamic>.from(data.map((x) => x.toJson())));

class MessagesModel {
  MessagesModel({
    this.message,
    this.readBy,
    this.type,
    this.msgId,
    this.secretKey,
    this.sentBy,
    this.viewBy,
    this.timeMilliSeconds,
    this.sentAt,
    this.isRead,
    this.image,
    this.base64Thumbnail,
    this.video,
    this.thumbnail,
    this.document,
    this.audio,
  });

  String? message;
  String? readBy;
  String? type;
  String? msgId;
  String? secretKey;
  String? sentBy;
  List<String>? viewBy;
  SentAt? timeMilliSeconds;
  SentAt? sentAt;
  bool? isRead;
  String? image;
  String? base64Thumbnail;
  String? video;
  String? thumbnail;
  String? document;
  String? audio;

  factory MessagesModel.fromJson(Map<String, dynamic> json) => MessagesModel(
        message: json["message"],
        readBy: json["readBy"],
        type: json["type"],
        msgId: json["msgId"],
        secretKey: json["secretKey"],
        sentBy: json["sentBy"],
        viewBy: json["viewBy"] == null
            ? null
            : List<String>.from(json["viewBy"].map((x) => x)),
        timeMilliSeconds: json["timeMilliSeconds"] == null
            ? null
            : SentAt.fromJson(json["timeMilliSeconds"]),
        sentAt: json["sentAt"] == null ? null : SentAt.fromJson(json["sentAt"]),
        isRead: json["isRead"],
        image: json["image"],
        base64Thumbnail: json["base64Thumbnail"],
        video: json["video"],
        thumbnail: json["thumbnail"],
        document: json["document"],
        audio: json["audio"],
      );

  Map<String, dynamic> toJson() => {
        "message": message,
        "readBy": readBy,
        "type": type,
        "msgId": msgId,
        "secretKey": secretKey,
        "sentBy": sentBy,
        "viewBy":
            viewBy == null ? null : List<dynamic>.from(viewBy!.map((x) => x)),
        "timeMilliSeconds":
            timeMilliSeconds == null ? null : timeMilliSeconds!.toJson(),
        "sentAt": sentAt == null ? null : sentAt!.toJson(),
        "isRead": isRead,
        "image": image,
        "base64Thumbnail": base64Thumbnail,
        "video": video,
        "thumbnail": thumbnail,
        "document": document,
        "audio": audio,
      };
}

class SentAt {
  SentAt({
    this.seconds,
    this.nanoseconds,
  });

  int? seconds;
  int? nanoseconds;

  factory SentAt.fromJson(Map<String, dynamic> json) => SentAt(
        seconds: json["seconds"],
        nanoseconds: json["nanoseconds"],
      );

  Map<String, dynamic> toJson() => {
        "seconds": seconds,
        "nanoseconds": nanoseconds,
      };
}
